//==============================================================================
// AboutDialog
//------------------------------------------------------------------------------
//
//==============================================================================
//
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//       1         2         3         4         5         6         7         8

import java.awt.*;
import java.io.*;
import ImagePanel;

//------------------------------------------------------------------------------
// * AboutDialog
//------------------------------------------------------------------------------
//
public class AboutDialog extends Dialog {

Button			mbtnOK;
Toolkit 		mToolkit = Toolkit.getDefaultToolkit();
ImagePanel 		mAboutImagePanel;
Image			mCurrentImage,mLastImage;

//------------------------------------------------------
// * AboutDialog
//------------------------------------------------------
//
public AboutDialog(Frame parent, String title) {
	super(parent, title, true);
		
	// Setup Display
	setBackground(Color.white);
	
	mCurrentImage = mToolkit.getImage("about1.gif");
	mLastImage = mToolkit.getImage("about2.gif");

	if (mCurrentImage != null){
		mAboutImagePanel = new ImagePanel(mCurrentImage);
	}
	else{
		System.out.println("Unable to load image.");
	}
	mAboutImagePanel.resize(320,260);
	setLayout(new FlowLayout());

	mbtnOK = new Button("OK");
	
	add(mAboutImagePanel);
	add(mbtnOK);

	//SetupGridComponents();
		
	this.resize(mAboutImagePanel.size());
	this.pack();
	//this.setResizable(false);
}


//------------------------------------------------------
// * show
//------------------------------------------------------
//  KJD Bug: Overridden for test purpoes. 
public void show(){
	//System.out.println("show  Dialog.width="+this.size().width+
	//" height="+this.size().height);
	//System.out.println("show  imagePanel.width="+mAboutImagePanel.size().width+
	//" height="+mAboutImagePanel.size().height);
	//System.out.println("show  image.width="+mAboutImagePanel.mImage.getWidth(null)+
	//" height="+mAboutImagePanel.mImage.getHeight(null));
	
	super.show();
}

//------------------------------------------------------
// * SetupGridComponents
//------------------------------------------------------
//  
public void SetupGridComponents(){
	GridBagLayout gridbag = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
			
	this.setLayout(gridbag);
	
	// Add image panel
	c.weightx = 1; 
	c.weighty = 1;
	c.gridx = 0;
	c.gridy = 0;
	c.gridwidth = 8;
	c.gridheight = 4;
	gridbag.setConstraints(mAboutImagePanel,c);
	this.add(mAboutImagePanel);	

	
	c.gridy = 4;
	c.gridwidth=8;
	c.gridheight=1;
	c.fill= GridBagConstraints.CENTER;
	gridbag.setConstraints(mbtnOK,c);
	this.add(mbtnOK);
}

//------------------------------------------------------
// * handleEvent
//------------------------------------------------------
//  
//
public boolean handleEvent(Event theEvent) {
	Object target = theEvent.target;
	
	if (theEvent.id == Event.MOUSE_DOWN){
	
		// A click in the image itself will toggle through the various about 
		// images...
		if (target == mAboutImagePanel){
		
			// Swap current and last images...
			Image tempImage = mCurrentImage;
			mCurrentImage = mLastImage;
			mLastImage = tempImage;
		
			// Display the new current image...
			mAboutImagePanel.SetImage(mCurrentImage);
		}
	}
	
	// it's good form to let the super class look at any unhandled events
	return super.handleEvent(theEvent);
}

//------------------------------------------------------
// * action
//------------------------------------------------------
//
public boolean action(Event event,Object arg){
	Object target = event.target;
	
	if (target == mbtnOK){
		this.hide();
	}
	
	return(true);
}

}//---| End AboutDialog |----------------------------------------------------



