//================================================================================
//  EXPQuality.java
//--------------------------------------------------------------------------------
// 	Reads base quality information from an .EXP file.  
//
//--------------------------------------------------------------------------------
//
//================================================================================
//
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//       1         2         3         4         5         6         7         8

import java.lang.*;
import java.awt.*;
import java.io.*;


//------------------------------------------------------------------------------
// * EXPQuality
//------------------------------------------------------------------------------
//
public class EXPQuality {
int [] Quality = new int[1500];  // Space for maximum bases in a trace. 
int NumBases=0;

//------------------------------------------------------
// * EXPQuality (EXPQuality)
//------------------------------------------------------
//
public EXPQuality(InputStream in) throws IOException{
	DataInputStream dataIn = new DataInputStream(in);
	
	int last,first;
	Integer tempInt = new Integer(0);
	
	String theBuf,intString;
	StringBufferInputStream streamBuf;
	DataInputStream dataBuf;

	// For every line in the file... 
	while ((theBuf = dataIn.readLine())!= null){

		// find the AV lines and parse out the ints...
		if (theBuf.indexOf("AV") >= 0){
			
			// Find two spaces (first and last) bracketing each number 
			// and convert to an int to store in the quality array.  The 
			// last space from the previous iteration becomes the first 
			// for the next iteration (via indexOf offset)  
			last = 0;
			first=0;
			while ((first = theBuf.indexOf(" ",last)) >=0){
				
				last = theBuf.indexOf(" ",first+1);
	
				// If there are no more spaces, look to the end of the line.
				if (last == -1) last = theBuf.length();
				
				// If there is something between the two spaces convert it
				// (i.e. ignore double spaces)
				if ((last-first) > 1){
					intString = theBuf.substring(first+1,last);
					try{
						Quality[NumBases++] = tempInt.parseInt(intString);
					}
					catch (NumberFormatException ex){
						System.out.println("Parse Int NumberFormatException:"+ex);
					}
				}
			}
		}
	}
}





} // ---| End EXPQuality class |-------------------------------------------------