//================================================================================
//  PhredQuality.java
//--------------------------------------------------------------------------------
// 	Reads base quality information from an .qual file.  
//
//--------------------------------------------------------------------------------
//
//================================================================================
//
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//       1         2         3         4         5         6         7         8

import java.lang.*;
import java.awt.*;
import java.io.*;


//------------------------------------------------------------------------------
// * PhredQuality
//------------------------------------------------------------------------------
//
public class PhredQuality {
int [] Quality = new int[3000];  // Space for maximum bases in a trace. 
int NumBases=0;

//------------------------------------------------------
// * PhredQuality (PhredQuality)
//------------------------------------------------------
//
public PhredQuality(InputStream in) throws IOException{
	DataInputStream dataIn = new DataInputStream(in);
	
	int last,first;
	Integer tempInt = new Integer(0);
	
	String theBuf,intString;
	StringBufferInputStream streamBuf;
	DataInputStream dataBuf;

	// Skip the first line which is a comment...
	theBuf = dataIn.readLine();
	
	// For every line in the file... 
	while ((theBuf = dataIn.readLine())!= null){
		last = 0;
		first = 0;
		
		// Read the first number on each line simply is demarked by the first space
		last = theBuf.indexOf(" ",0);
		
		// If there are no spaces, look to the end of the line.
		if (last == -1) last = theBuf.length();
		
		// If there is something between the space and the first char, convert it...		
		if (last >= 1){
			intString = theBuf.substring(0,last);
			try{
				Quality[NumBases++] = tempInt.parseInt(intString);
					//System.out.print(Quality[NumBases-1]+" ");
			}
			catch (NumberFormatException ex){
					System.out.println("Parse Int NumberFormatException:"+ex);
			}
		}
		
		// Read the rest of the numbers on each line...
		// Find two spaces (first and last) bracketing each number 
		// and convert to an int to store in the quality array.  The 
		// last space from the previous iteration becomes the first 
		// for the next iteration (via indexOf offset)  
		while ((first = theBuf.indexOf(" ",last)) >=0){
				
			last = theBuf.indexOf(" ",first+1);
	
			// If there are no more spaces, look to the end of the line.
			if (last == -1) last = theBuf.length();
				
			// If there is something between the two spaces convert it
			// (i.e. ignore double spaces)
			if ((last-first) > 1){
				intString = theBuf.substring(first+1,last);
				try{
					Quality[NumBases++] = tempInt.parseInt(intString);
					//System.out.print(Quality[NumBases-1]+" ");
				}
				catch (NumberFormatException ex){
					//System.out.println("Parse Int NumberFormatException:"+ex);
				}
			}
		}
		//System.out.println("");
	}
}





} // ---| End PhredQuality class |-------------------------------------------------