//================================================================================
// QualityCanvas
//--------------------------------------------------------------------------------
//
//
//================================================================================
//
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//       1         2         3         4         5         6         7         8
import java.applet.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import PanelInfo;

//------------------------------------------------------------------------------
// * QualityCanvas
//------------------------------------------------------------------------------
//
class QualityCanvas extends Canvas {
Trace mTrace;
PanelInfo mPanelInfo;
double PixelsPerSample;
boolean mGraph=true,mTemp=true;
boolean mInvalid;
Color qualColor[] = new Color[12];
	
// Variables for offscreen graphics manipulation. 
protected Dimension offDimension;
protected Graphics offGraphics;
protected Image offImage;

//------------------------------------------------------
// * QualityCanvas
//------------------------------------------------------
//
QualityCanvas(Trace theTrace,PanelInfo theInfo){
	mTrace=theTrace;
	mPanelInfo = theInfo;

	qualColor[0]= new Color(255,  0,  0);		// 0-4
	qualColor[1]= new Color(255,  60,  0);		// 5-9
	qualColor[2]= new Color(255,127,0);       // 10-14
	qualColor[3]= new Color(255,255,0);       // 15-19
	qualColor[4]= new Color(127,255,0);       // 20-24
	qualColor[5]= new Color(0,255,0);         // 25-29
	qualColor[6]= new Color(0,255,127);       // 30-34
	qualColor[7]= new Color(0,255,255);       // 35-39
	qualColor[8]= new Color(0,127,255);       // 40-44
	qualColor[9]= new Color(0,0,255);         // 45-49
	qualColor[10]= new Color(0,0,255);        // 50-54
	qualColor[11]= new Color(0,0,255);        // 55-60


		 /* Simple, clear boundaries. 

	qualColor[0] = Color.red;      // 0-4
	qualColor[1] = Color.red;      // 5-9
	qualColor[2] = Color.orange;   // 10-14
	qualColor[3] = Color.yellow;   // 14-19
	qualColor[4] = Color.green;
	qualColor[5] = Color.green;
	qualColor[6] = Color.green;
  	qualColor[7]= Color.blue;
  	qualColor[8]= Color.blue;
  	qualColor[9]= Color.blue;
  	qualColor[10]= Color.blue;
  	qualColor[11]= Color.blue;
		 */


	/*
	qualColor[0] = Color.red;      // 0-4
	qualColor[1] = Color.red;      // 5-9
	qualColor[2] = Color.orange.darker();   // 10-14
	qualColor[3] = Color.orange.darker();   // 15-19
	qualColor[4] = Color.yellow;   // 20-24
	qualColor[5] = Color.yellow;   // 25-29
	qualColor[6] = Color.green;    // 30-34
	qualColor[7] = Color.green;    // 35-39
	qualColor[8] = Color.blue;     // 40-44
	qualColor[9] = Color.blue;     // 45-49
	qualColor[10] = Color.blue;    // 50-54
	qualColor[11] = Color.blue;    // 50-54
	*/ 


	/*
	qualColor[0]= new Color(255,  0,  0);		
	qualColor[1]= new Color(255,  0,153);		
	qualColor[2]= new Color(255,255,  0).darker();// 10-14  Yellow (255 255 0)
	qualColor[3]= new Color(204,255,  0).darker();//	15-19   Green (204 255 0)
	qualColor[4]= new Color(102,204,204);		
	qualColor[5]= new Color(102,153,153);		
	qualColor[6]= new Color(102,153,204);		
	qualColor[7]= new Color( 51,102,255);		
	qualColor[8]= new Color( 51, 51,255);		
	qualColor[9]= new Color( 51,  0,204);		
	qualColor[10]=new Color( 51,  0,204);
	*/
	
}

//------------------------------------------------------
// * SetNewTrace
//------------------------------------------------------
//
public void SetNewTrace (Trace theTrace)
{
	mTrace = theTrace;
	mInvalid = true;
}

//------------------------------------------------------
// * minimumSize
//------------------------------------------------------
//

public Dimension minimumSize(){
	return (new Dimension(200,27));
}

//------------------------------------------------------
// * preferredSize
//------------------------------------------------------
//	
public Dimension preferredSize(){
	return (new Dimension(600,27));
}

//------------------------------------------------------
// * FinishInit
//------------------------------------------------------
//	
public void FinishInit(){
	//System.out.println("Quality Finish Init");
	//System.out.println("Quality size.width="+size().width);
	PixelsPerSample = ((double)size().width/mPanelInfo.winSampleWidth);
	repaint();
}

//------------------------------------------------------
// * setGraph
//------------------------------------------------------
//
public void setGraph(boolean state)
{
	mGraph = state;
}

//------------------------------------------------------
// * SetTemp
//------------------------------------------------------
//
public void setTemp(boolean state)
{
	mTemp = state;
}


//------------------------------------------------------
// * paintQualTemperatureGraph
//------------------------------------------------------
// Called whenever something alters the canvas.  
//
public void paintQualTemperatureGraph(Graphics g)
{
	int Index,x,start;
	int fontWidth;
	Font 				theFont =g.getFont();
	FontMetrics		theMetrics= getFontMetrics(theFont);
		
	fontWidth = theMetrics.stringWidth(String.valueOf("4"));
			
	PixelsPerSample =  ((double)size().width/mPanelInfo.winSampleWidth);	
	start = mPanelInfo.winSampleStart;
	
	// Find the first and last base within our window 
   int BaseStart = mTrace.GetNextBaseAfterSample(start);
   int BaseEnd = mTrace.GetLastBaseBeforeSample(mPanelInfo.winSampleEnd);
   
   // Draw the quality graph for all the bases in this window. 
   int qual;
	for (Index=BaseStart;Index <= BaseEnd;Index++) {
		qual = mTrace.getQual(Index);
		g.setColor(qualColor[(qual/5)]);
		x = (int)((mTrace.basePosition[Index] - start)* PixelsPerSample);
		g.fillRect(x-(fontWidth/2),25-(qual/2),fontWidth,(qual/2));
	} 
 }

//------------------------------------------------------
// * paintQualGraph
//------------------------------------------------------
// Called whenever something alters the canvas.  
//
public void paintQualGraph(Graphics g)
{
	int Index,x,start;
	int fontWidth;
	Font 				theFont =g.getFont();
	FontMetrics		theMetrics= getFontMetrics(theFont);	
	fontWidth = theMetrics.stringWidth(String.valueOf("4"));
		
	PixelsPerSample =  ((double)size().width/mPanelInfo.winSampleWidth);	
	start = mPanelInfo.winSampleStart;
	
	// Find the first and last base within our window 
   int BaseStart = mTrace.GetNextBaseAfterSample(start);
   int BaseEnd = mTrace.GetLastBaseBeforeSample(mPanelInfo.winSampleEnd);
   
   // Draw the quality graph for all the bases in this window. 
   int qual;
	for (Index=BaseStart;Index <= BaseEnd;Index++) {
		qual = mTrace.getQual(Index);
		g.setColor(mPanelInfo.baseColor[mTrace.getBase(Index)]);
		x = (int)((mTrace.basePosition[Index] - start)* PixelsPerSample);
		g.fillRect(x-(fontWidth/2),25-(qual/2),fontWidth,(qual/2));
	} 
}
 
//------------------------------------------------------
// * paintQualTemperatureNumbers
//------------------------------------------------------
// Called whenever something alters the canvas.  
//
public void paintQualTemperatureNumbers(Graphics g)
{
	int Index,x,start;
	int fontMid;
	Font 				theFont =g.getFont();
	FontMetrics		theMetrics= getFontMetrics(theFont);	
	
	PixelsPerSample =  ((double)size().width/mPanelInfo.winSampleWidth);
	
	start = mPanelInfo.winSampleStart;
	
	// Find the first and last base within our window 
   int BaseStart = mTrace.GetNextBaseAfterSample(start);
   int BaseEnd = mTrace.GetLastBaseBeforeSample(mPanelInfo.winSampleEnd);
   
   // Draw the quality values for all the bases in this window. 
   int qual;
	for (Index=BaseStart;Index <= BaseEnd;Index++) {
		qual = mTrace.getQual(Index);
		g.setColor(qualColor[(qual/5)]);
		x = (int)((mTrace.basePosition[Index] - start)* PixelsPerSample);
		fontMid = theMetrics.stringWidth(String.valueOf(qual))/2;	
		g.drawString(String.valueOf(qual),x-fontMid,20);
	} 
}

//------------------------------------------------------
// * paintQualNumbers
//------------------------------------------------------
// Called whenever something alters the canvas.  
//
public void paintQualNumbers(Graphics g)
{
	int Index,x,start;
	int fontMid;
	Font 				theFont =g.getFont();
	FontMetrics		theMetrics= getFontMetrics(theFont);	
		
	PixelsPerSample =  ((double)size().width/mPanelInfo.winSampleWidth);
	
	// Let this quality value be a proxy for all of them.  This is 
	// to speed up drawing.  Cost is that some values will not be precisely
	// centered. 
	//fontMid = 
	//	getFontMetrics(g.getFont()).stringWidth(String.valueOf("44"))/2;
	
	start = mPanelInfo.winSampleStart;
	
	// Find the first and last base within our window 
   int BaseStart = mTrace.GetNextBaseAfterSample(start);
   int BaseEnd = mTrace.GetLastBaseBeforeSample(mPanelInfo.winSampleEnd);
   
   // Draw the quality values for all the bases in this window. 
   int qual;
	for (Index=BaseStart;Index <= BaseEnd;Index++) {
		qual = mTrace.getQual(Index);
		g.setColor(mPanelInfo.baseColor[mTrace.getBase(Index)]);
		
		x = (int)((mTrace.basePosition[Index] - start)* PixelsPerSample);
			
		fontMid = theMetrics.stringWidth(String.valueOf(qual))/2;	
		g.drawString(String.valueOf(qual),x-fontMid,20);
	} 
}
 
//------------------------------------------------------
// * update
//------------------------------------------------------
// Reduce flicker with double buffering, drawing the display in 
// an offscreen window of the same size and slaping the whole thing 
// up at once.  
public void update(Graphics g){

	//System.out.println("Quality update");
	Dimension d = size();
	
	// create offscreen graphics context. 
	if ((offGraphics == null) ||
		(d.width != offDimension.width) ||
		(d.height != offDimension.height)){
		offDimension = d;
		offImage = createImage(d.width,d.height);
		offGraphics = offImage.getGraphics();
		offGraphics.setColor(Color.black);
	}
	
	//  Clear the previous frame
	offGraphics.setColor(getBackground());
	offGraphics.fillRect(0,0,d.width,d.height);
	
	// Paint the frame into the image.
	if (mGraph == true){
		if (mTemp == true){
			paintQualTemperatureGraph(offGraphics);
		}
		else
		{
			paintQualGraph(offGraphics);
		}
	}
	else{
		if (mTemp == true){
			paintQualTemperatureNumbers(offGraphics);
		}
		else
		{
			paintQualNumbers(offGraphics);
			
		}
	}
		
	// Paint the image onto the screen.
	g.drawImage(offImage,0,0,null);			
}

//------------------------------------------------------
// * paint
//------------------------------------------------------
// paint previously created image or create one if none exists.
// repaint() does not reliably call update (at least, I can not see 
// the factors that determine when it happens), but it does seem
// to reliably call either paint or update.   As a result,  there is a hook 
// here to call update if there is not already an offscreen image. 

public void paint(Graphics g){
	
	Dimension d = size();
	
	// If this is the first time, update the display..
	if (offImage == null){
		update(g);
		return;
	}
	
	if (mInvalid){
		//System.out.println("QualityCanvas.paint:mInvalid");
		mInvalid = false;
		update(g);
		return;
	}
	
	// If the size has changed, rescale the axes and update the display...
	if	((d.width != offDimension.width) ||
		(d.height != offDimension.height)){
		update(g);
		return;
	}
	
	// If the contents haven't changed somehow, just repaint previous image. 
	g.drawImage(offImage,0,0,null);
}


} //------| End QualityCanvas |-------------------------------------------
 
