//================================================================================
//  TraceViewerApplet.java
//--------------------------------------------------------------------------------
//
// Applet which contains a TracePanel.   Multiple trace panels within this
// single applet are easily accomodated.   
//
//================================================================================
//
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//       1         2         3         4         5         6         7         8
import java.applet.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import Trace;
import TraceStream;
import TracePanel;

//------------------------------------------------------------------------------
// * TraceViewerApplet
//------------------------------------------------------------------------------
//
public class TraceViewerApplet extends Applet
{	
	boolean isApplication=false;
	TracePanel mTracePanel;


//------------------------------------------------------
// * init (TraceViewerApplet)
//------------------------------------------------------
//
public void init()
{	
	 System.out.println("Hello!");
	 
	 String traceFileName;
	 String expFileName;
	 
	 traceFileName = this.getParameter("trace-name");
	 expFileName = this.getParameter("exp-name");
	 
	 System.err.println("trace-name ="+traceFileName);
	 System.err.println("exp-name ="+expFileName);
	 
	 initFromURL(getDocumentBase(),traceFileName,expFileName);
}

//------------------------------------------------------
// * initFromURL
//------------------------------------------------------
// As an applet this is targeted for use in a web browser.
// For security most browsers do not allow any kind of direct access to the
// file system so it is necessary to go through a web server via a URL.  
//
public void initFromURL(URL DocumentBase,String traceFileName,String expFileName)
{
	if (traceFileName == "") {  
   		System.out.println("No filename given.");
   		return;
	}
	
	try {
		// TraceStream should throw an exception if fileName not valid or 
		// other problems occur.  If no problems occur, theStream should
		// contain a valid trace. 
    	TraceStream theTraceStream=new TraceStream(DocumentBase,traceFileName,expFileName);
    	
    	InstallTracePanel(theTraceStream.theTrace);	
    }
    catch (MalformedURLException ex) {
		System.out.println("Malformed URL");
    } // end catch
    catch (IOException ex) {
		String exMessage = ex.getMessage();
		String exName = ex.getClass().getName();
		System.out.println("IO ERROR: " + exName + " : " + exMessage);
    }
}

//------------------------------------------------------
// * InstallTracePanel
//------------------------------------------------------
// Create the TracePanel and add it to the applet.  
//
public void InstallTracePanel(Trace theTrace)
{
	int i=0;
	mTracePanel = new TracePanel(theTrace);
		
	// Make panel a little smaller than the 
	//mTracePanel.resize(this.size().width-8,this.size().height-8);
	mTracePanel.theTraceCanvas.resize(600,100);
	mTracePanel.theQualityCanvas.resize(600,27);
	//mTracePanel.theTraceCanvas.resize(this.size().width-100,this.size().height-100);
	//mTracePanel.theQualityCanvas.resize(this.size().width-100,27);

   this.setLayout(new FlowLayout());
   this.add(mTracePanel);
   
  	mTracePanel.FinishInit();
	mTracePanel.validate();
   
   this.validate();
  // System.out.println("InstallTracePane Applet width="+size().width+
  // "height="+size().height);
  // System.out.println("mTracePanel width="+mTracePanel.size().width+
  // "height="+mTracePanel.size().height);
   mTracePanel.resize(700,150);
   mTracePanel.theTraceCanvas.resize(600,100);
   mTracePanel.theQualityCanvas.resize(600,27);
   mTracePanel.repaint();
}


//------------------------------------------------------
// * paint
//------------------------------------------------------
//
public void paint (Graphics g){
	//System.out.println("Applet.paint");
	//resize(900,250);	
}
	

}//---| End TraceViewerApplet class |---------------------------------------------


